global.Sunshiner = object_add();
global.SunshinePath = argument0;

object_event_add(global.Sunshiner, ev_create, 0, '
    music = sound_add(global.SunshinePath + "\sunshine.mp3", 3, true);
    AudioControlPlaySong(music, false);

    startTime = date_current_datetime();

    var fp, cur;
    fp = file_text_open_read(global.SunshinePath + "\lyrics.txt");
    data = ds_list_create();
    while (!file_text_eof(fp)) {
        ds_list_add(data, file_text_read_real(fp));
        file_text_readln(fp);
        ds_list_add(data, file_text_read_string(fp));
        file_text_readln(fp);
    }
    file_text_close(fp);
');
object_event_add(global.Sunshiner, ev_step, ev_step_end, '
    if (date_second_span(startTime, date_current_datetime()) > 304) {
        AudioControlPlaySong(music, false);
        startTime = date_current_datetime();
    }
');
object_event_add(global.Sunshiner, ev_draw, 0, '
    var xoffset, yoffset, xsize, ysize, time, text, delta, display, scalefactor;

    xoffset = view_xview[0];
    yoffset = view_yview[0];
    xsize = view_wview[0];
    ysize = view_hview[0];

    display = "";
    delta = date_second_span(startTime, date_current_datetime());
    for (i = ds_list_size(data) - 1; i >= 0; i -= 2) {
        time = ds_list_find_value(data, i - 1);
        text = ds_list_find_value(data, i);
        if (delta >= time) {
            display = text;
            break;
        }
    }

    draw_set_halign(fa_center);
    draw_set_valign(fa_middle);
    draw_set_color(c_yellow);
    draw_set_alpha(0.75);

    scalefactor = (xsize - 50) / string_width(display);

    draw_text_transformed(xoffset + xsize / 2, yoffset + ysize * 0.75, display, scalefactor, scalefactor, 0);
    draw_set_alpha(1);
');
object_event_add(global.Sunshiner, ev_destroy, 0, '
    ds_list_destroy(data);
');

object_event_add(Spectator, ev_create, 0, '
    if (!instance_exists(global.Sunshiner))
        instance_create(0, 0, global.Sunshiner);
');
